#include <linux/pci.h>
#include <linux/device.h>
/********************** NE PCIE ID******************/
#define PCI_VENDOR_ID_NE		(0x10EE)
#define PCI_DEVICE_ID_NE		(0x8034)

/****************paladium PCIE ID*******************/
#define PCI_VENDOR_ID_PAL		(0x1EC8)// (0x10DE)
#define PCI_DEVICE_ID_PAL		(0x1EB8)//(0x1EB8)

/**********************VF PCIE ID*******************/
#define PCI_VENDOR_ID_VF		(0x1EC8)// (0x10DE)
#define PCI_DEVICE_ID_VF		(0x1EA8)//(0x1EB8)
#define PCI_DEVICE_ID_G1P_PAL_VF		(0x8811)

/**********************Compatible PCIE ID***********/
#define PCI_VENDOR_ID_INNO			(0x1EC8)
#define PCI_DEVICE_ID_INNO			(0x1EB8)
#define PCI_DEVICE_ID_G1_SOC		(0x8800)
#define PCI_DEVICE_ID_G1_PAL		(0x8800)
#define PCI_DEVICE_ID_G1_NE			(0x8800)
#define PCI_DEVICE_ID_G0_SOC		(0x9800)
#define PCI_DEVICE_ID_G0_PAL		(0x9800)
#define PCI_DEVICE_ID_G0_NE			(0x9800)
#define PCI_DEVICE_ID_G1P_SOC		(0x8810)
#define PCI_DEVICE_ID_G1P_PAL		(0x8810)
#define PCI_DEVICE_ID_G1P_NE		PCI_DEVICE_ID_NE
#define PCI_DEVICE_ID_G0M_SOC		(0x9810)
#define PCI_DEVICE_ID_G0M_PAL		(0x9810)
#define PCI_DEVICE_ID_G0M_NE		PCI_DEVICE_ID_NE

/**********************Alias Compatible PCIE ID***********/
#define PCI_VENDOR_ID_INNO_ALIAS	(0x1FE0)
#define PCI_DEVICE_ID_G1_SOC_ALIAS	(0x1000)
#define PCI_DEVICE_ID_G1P_SOC_ALIAS	(0x1010)
#define PCI_DEVICE_ID_G0_SOC_ALIAS      (0x2000)
#define PCI_DEVICE_ID_G0M_SOC_ALIAS     (0x2010)

#define PCI_VENDOR_ID_INNO_ALIAS_GT (0x1FF8)

#define INV_OFFSET 0x20800000
#define VIS_OFFSET 0x6400000
#define DIFF_OFFSET 0x3200000
#define G0M_VRAM_ADDR_START 0x6000000000
#define COMMON_VRAM_ADDR_START 0x1000000000

#define ReadReg64(addr)                 (*(volatile unsigned long *)(addr))
#define WriteReg64(addr, val)           (*(volatile unsigned long *)(addr) = (unsigned long)(val))

typedef struct pci_dma_dev_info
{
	uint16_t vendor_id;
	uint16_t device_id;

}pci_dma_dev_info_t;

enum dma_type {
	AXI_DMA = 0,
	AXI_DMAR,
	PCIE_DMA,
	NONE_DMA,
};

struct dma_memcpy_test_data {
	void **srcs;
	void **dsts;
	int  *sizes;
	int  cnt;
	int  dma_type;
};